.\" t
.\" @(#)FvwmClean.1	1/12/94
.TH FvwmClean 1.20 "Jan 28 1994"
.UC
.SH NAME
FvwmClean \- the FVWM desktop clutter reduction module
.SH SYNOPSIS
FvwmClean is spawned by fvwm, so no command line invocation will work.

.SH DESCRIPTION
The FvwmClean module performs actions on windows which have not had
the keyboard focus for a specific length of time. This is intended to
help alleviate the problem of leaving programs running in unused
portions of your desktop.

FvwmClean reads the same .fvwmrc file as fvwm reads when it starts up,
and looks for lines similar to "*FvwmNoClutter 3600 Iconify".

.SH COPYRIGHTS
The FvwmClean program, and the concept for
interfacing this module to the Window Manager, are all original work
by Robert Nation

Copyright 1994, Robert Nation. No guarantees or warranties or anything
are provided or implied in any way whatsoever. Use this program at your
own risk. Permission to use this program for any purpose is given,
as long as the copyright is kept intact. 


.SH INITIALIZATION
During initialization, \fIFvwmClean\fP will eventually search a 
configuration file which describes the time-outs and actions to take.
The configuration file is the same file that fvwm used during initialization.

If the FvwmClean executable is linked to another name, ie ln -s
FvwmClean OtherClutter, then another module called OtherClutter can be
started, with a completely different configuration than FvwmClean,
simply by changing the keyword  FvwmClean to OtherClutter. This way multiple
clutter-reduction programs can be used.

.SH INVOCATION
FvwmClean can be invoked by inserting the line 'Module FvwmClean' in
the .fvwmrc file. This can be placed on a line by itself, if FvwmClean
is to be spawned during fvwm's initialization, or can be bound to a
menu or mouse button or keystroke to invoke it later. Fvwm will search
directory specified in the ModulePath configuration option to attempt
to locate FvwmClean.

.SH CONFIGURATION OPTIONS
FvwmClean reads the same .fvwmrc file as fvwm reads when it starts up,
and looks for lines similar to "*FvwmClean 3600 Iconify". The format
of these lines is "*FvwmClean [time] [command]", where command is any
fvwm built-in command, and time is the time in seconds between when a
window looses focus and when the command is executed. At most 3
actions can be specified.


.SH AUTHOR
Robert Nation (nation@rocket.sanders.lockheed.com).

